import uno
import unohelper
import csv
import os
import logging

from com.sun.star.task import XJob
from com.sun.star.ui import XContextMenuInterceptor
from com.sun.star.ui.ContextMenuInterceptorAction import IGNORED, CANCELLED, EXECUTE_MODIFIED, CONTINUE_MODIFIED

from myhelper import MyUnoHelper
from lookup import SphLookup
from lookup import get_syllable
from myhelper import access_by_name

dir_path = os.path.dirname(os.path.realpath(__file__))

logging.basicConfig(filename=dir_path+'\\Addon.txt', level=logging.DEBUG)

def logException(name, e):
    logging.debug(name + "Exception " + str(type(e)) + " message " + str(e) + " args " + str(e.args))

def l(txt):
    loggin.debug(txt)

#Methode für einfügen von Text in die Dropbox
def insertMenuItem(menu, text, command):

    #Menu item root
    try:
        xRootMenuEntry = menu.createInstance("com.sun.star.ui.ActionTrigger")
        xRootMenuEntry.setPropertyValue("Text", text)
        xRootMenuEntry.setPropertyValue("CommandURL", command)

        #SubMenu instanz
        xSubMenuContainer = menu.createInstance("com.sun.star.ui.ActionTriggerContainer")
        xRootMenuEntry.setPropertyValue("SubContainer", xSubMenuContainer)

        dir_path = os.path.dirname(os.path.realpath(__file__))
        with open(dir_path + '\\eggs.csv') as csvfile:
            reader = csv.reader(csvfile, delimiter=',', quotechar='|')
            i = 0
            for row in reader:

                xSubMenuChangeContainer = menu.createInstance("com.sun.star.ui.ActionTriggerContainer")
                xMenuEntry = menu.createInstance("com.sun.star.ui.ActionTrigger")
                xMenuEntry.setPropertyValue("Text", "Place")
                xMenuEntry.setPropertyValue( "CommandURL", "service:addons.itjung.SimplePlaceholder.Job?inputtext="+str(row[1]))
                xSubMenuChangeContainer.insertByIndex(0, xMenuEntry)

                xMenuEntry = menu.createInstance("com.sun.star.ui.ActionTrigger")
                xMenuEntry.setPropertyValue("Text", "Change")
                xMenuEntry.setPropertyValue( "CommandURL", "service:addons.itjung.SimplePlaceholder.Job?change="+str(row[1])+"="+str(row[0])+"="+str(i))
                xSubMenuChangeContainer.insertByIndex(1, xMenuEntry)

                speccommand = "service:addons.itjung.SimplePlaceholder.Job?inputtext=" + str(row[1])
                xMenuEntry = menu.createInstance("com.sun.star.ui.ActionTrigger")
                xMenuEntry.setPropertyValue("Text", row[0])
                xMenuEntry.setPropertyValue("CommandURL", speccommand)
                xMenuEntry.setPropertyValue("SubContainer", xSubMenuChangeContainer)
                xSubMenuContainer.insertByIndex(i, xMenuEntry)
                i = i + 1
            csvfile.close();
        # create a line separator for our new help sub menu
        xSeparator = menu.createInstance("com.sun.star.ui.ActionTriggerSeparator")
        xSeparator.setPropertyValue( "SeparatorType", 0)
        xSubMenuContainer.insertByIndex(i, xSeparator)

        i = i + 1
        # SubMenu Items 3 Buy Premium
        buyurl = "service:addons.itjung.SimplePlaceholder.Job?premium"
        xMenuEntry = menu.createInstance("com.sun.star.ui.ActionTrigger")
        xMenuEntry.setPropertyValue("Text", "More functions")
        xMenuEntry.setPropertyValue( "CommandURL", buyurl)
        xSubMenuContainer.insertByIndex(i, xMenuEntry)


        #Menu list
        menu.insertByIndex(0, xRootMenuEntry)
    except Exception as e:
        logException("trigger()", e)



class SphContextMenuInterceptor(unohelper.Base, XContextMenuInterceptor):
    def __init__(self, helper):
        self.helper = helper
        filepath = helper.get_package_file( "addons.itjung.SimplePlaceholder", "phtab.pkl" )
        self.lookup = SphLookup( filepath )

    def insert_menuitem_with_placeholder(self, xContextMenu):

        xRootMenuEntry = insertMenuItem(xContextMenu, "Simple Placeholder",
                       "service:addons.itjung.SimplePlaceholder.Job?placeholder")
        return CONTINUE_MODIFIED

    def notifyContextMenuExecute(self, aEvent):
        xContextMenu = aEvent.ActionTriggerContainer
        return self.insert_menuitem_with_placeholder(xContextMenu)

class SphAnnotateRegistrar(unohelper.Base, XJob):
    def __init__(self, ctx):
        self.ctx = ctx

    def execute(self, args):
        try:
            self.do_execute(args)

        except Exception as e:
            logging.debug("execute exception="+str(e))

    def do_execute(self, args):
        environment = access_by_name( args, "Environment" )
        model = None
        if environment:
            model = access_by_name( environment, "Model" )

        helper = MyUnoHelper(self.ctx, model)
        interceptor = SphContextMenuInterceptor( helper )
        if helper.is_text_document() and helper.controller():
            helper.controller().registerContextMenuInterceptor(interceptor)


# pythonloader looks for a static g_ImplementationHelper variable
g_ImplementationHelper = unohelper.ImplementationHelper()

g_ImplementationHelper.addImplementation( \
    SphAnnotateRegistrar,  # UNO object class
    "addons.itjung.SimplePlaceholder.Registrar",  # Implementation name
    ("com.sun.star.task.Job",), )  # List of implemented services
